require 'launchy'
require 'colored'

class ErrorRescue
	def initialize(file)
		exit unless is_ruby?(file)
		@file_name = file
		@file = File.open(file, "rb")
		@message = nil
		track_code
		ask_response
	end

	def is_ruby?(file)
		if file[-3..-1] != ".rb"
			puts "You can only go snorkeling with Ruby!".cyan 
			false
		else
			true
		end
	end

	def track_code
		begin
			eval(@file.read)
		rescue => ex
			@message = ex.message
			@line = ex.backtrace
		end
		return if @message == nil
	end

	def find_line
		@line.map do |e|
			e.match(/^(.+?):(\d+)(|:in `(.+)')$/)
			$2
		end
	end

	def ask_response
		puts "On line #{find_line[1]} of #{@file_name}:  #{@message.capitalize}".blue
		puts "Would you like to search your error?"
		launch_search($stdin.gets.chomp)
	end

	def launch_search(response)
		new_message = @message.split(" ").join("+").downcase
		if response.start_with? 'y'
			Launchy.open("https://www.google.com/#q=#{new_message}+ruby")
		else
			puts "Have a nice day!"
		end
	end

end

